Package org.apache.struts2.components

# Class ComboBox

java.lang.Object
org.apache.struts2.components.Component
org.apache.struts2.components.UIBean
org.apache.struts2.components.TextField
org.apache.struts2.components.ComboBox

public class ComboBox extends TextField

The combo box is basically an HTML INPUT of type text and HTML SELECT grouped together to give you a combo box functionality. You can place text in the INPUT control by using the SELECT control or type it in directly in the text field.

In this example, the SELECT will be populated from id=year attribute. Counter is itself an Iterator. It will span from first to last. The population is done via javascript, and requires that this tag be surrounded by a <form>.

Note that unlike the <s:select/> tag, there is no ability to define the individual <option> tags' id attribute or content separately. Each of these is simply populated from the toString() method of the list item. Presumably this is because the select box isn't intended to actually submit useful data, but to assist the user in filling out the text field.

Examples

     JSP:
     <-- Example One -->
     <s:bean name="struts.util.Counter" var="year">
       <s:param name="first" value="text('firstBirthYear')"/>
       <s:param name="last" value="2000"/>

       <s:combobox label="Birth year" size="6" maxlength="4" name="birthYear" list="#year"/>
     </s:bean>

     <-- Example Two -->
     <s:combobox
         label="My Favourite Fruit"
         name="myFavouriteFruit"
         list="{'apple','banana','grape','pear'}"
         headerKey="-1"
         headerValue="--- Please Select ---"
         emptyOption="true"
         value="banana" />

     <-- Example Two -->
     <s:combobox
        label="My Favourite Color"
        name="myFavouriteColor"
        list="#{'red':'red','green':'green','blue':'blue'}"
        headerKey="-1"
        headerValue="--- Please Select ---"
        emptyOption="true"
        value="green" />

     Velocity:
     #tag( ComboBox "label=Birth year" "size=6" "maxlength=4" "name=birthYear" "list=#year" )

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected String`
  `emptyOption`
  `protected String`
  `headerKey`
  `protected String`
  `headerValue`
  `protected String`
  `list`
  `protected String`
  `listKey`
  `protected String`
  `listValue`
  `static final String`
  `TEMPLATE`

  ### Fields inherited from class org.apache.struts2.components.TextField

  `maxlength, readonly, size, type`

  ### Fields inherited from class org.apache.struts2.components.UIBean

  `accesskey, ATTR_FIELD_VALUE, ATTR_NAME_VALUE, ATTR_VALUE, cssClass, cssErrorClass, cssErrorStyle, cssStyle, defaultTemplateDir, defaultUITheme, disabled, dynamicAttributes, errorPosition, id, javascriptTooltip, key, label, labelPosition, labelSeparator, name, onblur, onchange, onclick, ondblclick, onfocus, onkeydown, onkeypress, onkeyup, onmousedown, onmousemove, onmouseout, onmouseover, onmouseup, onselect, request, requiredLabel, requiredPosition, response, tabindex, template, templateDir, templateEngineManager, templateSuffix, theme, title, tooltip, tooltipConfig, tooltipCssClass, tooltipDelay, tooltipIconPath, uiStaticContentPath, uiThemeExpansionToken, value`

  ### Fields inherited from class org.apache.struts2.components.Component

  `actionMapper, attributes, COMPONENT_STACK, devMode, escapeHtmlBody, performClearTagStateForTagPoolingServers, stack, standardAttributesMap, throwExceptionOnELFailure`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ComboBox(ValueStack stack, jakarta.servlet.http.HttpServletRequest request, jakarta.servlet.http.HttpServletResponse response)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `evaluateExtraParams()`
  `protected Object`
  `findListValue()`
  `protected String`
  `getDefaultTemplate()`
  A contract that requires each concrete UI Tag to specify which template should be used as a default.
  `void`
  `setEmptyOption(String emptyOption)`
  `void`
  `setHeaderKey(String headerKey)`
  `void`
  `setHeaderValue(String headerValue)`
  `void`
  `setList(String list)`
  `void`
  `setListKey(String listKey)`
  `void`
  `setListValue(String listValue)`

  ### Methods inherited from class org.apache.struts2.components.TextField

  `setMaxlength, setMaxLength, setReadonly, setSize, setType`

  ### Methods inherited from class org.apache.struts2.components.UIBean

  `addFormParameter, applyValueParameter, buildTemplateName, copyAttributes, enableAncestorFormCustomOnsubmit, end, ensureAttributeSafelyNotEscaped, escape, evaluateNameValue, evaluateParams, getId, getTemplate, getTemplateDir, getTheme, getTooltipConfig, getValueClassType, lazyEvaluation, mergeTemplate, populateComponentHtmlId, setAccesskey, setCssClass, setCssErrorClass, setCssErrorStyle, setCssStyle, setDefaultTemplateDir, setDefaultUITheme, setDisabled, setDynamicAttributes, setErrorPosition, setId, setJavascriptTooltip, setKey, setLabel, setLabelPosition, setLabelSeparator, setName, setOnblur, setOnchange, setOnclick, setOndblclick, setOnfocus, setOnkeydown, setOnkeypress, setOnkeyup, setOnmousedown, setOnmousemove, setOnmouseout, setOnmouseover, setOnmouseup, setOnselect, setRequiredLabel, setRequiredPosition, setStaticContentPath, setStyle, setTabindex, setTemplate, setTemplateDir, setTemplateEngineManager, setTheme, setTitle, setTooltip, setTooltipConfig, setTooltipCssClass, setTooltipDelay, setTooltipIconPath, setUIThemeExpansionToken, setValue`

  ### Methods inherited from class org.apache.struts2.components.Component

  `addAllAttributes, addParameter, completeExpression, determineActionURL, determineNamespace, end, escapeHtmlBody, fieldError, findAncestor, findString, findString, findValue, findValue, findValue, getAttributes, getComponentStack, getNamespace, getPerformClearTagStateForTagPoolingServers, getStack, getStandardAttributes, isAcceptableExpression, isValidTagAttribute, popComponentStack, setActionMapper, setDevMode, setEscapeHtmlBody, setNotExcludedAcceptedPatterns, setPerformClearTagStateForTagPoolingServers, setThrowExceptionsOnELFailure, setUrlHelper, start, stripExpression, toString, usesBody`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### TEMPLATE

    public static final String TEMPLATE
    See Also:
      - Constant Field Values

  - ### list

    protected String list

  - ### listKey

    protected String listKey

  - ### listValue

    protected String listValue

  - ### headerKey

    protected String headerKey

  - ### headerValue

    protected String headerValue

  - ### emptyOption

    protected String emptyOption

- ## Constructor Details

  - ### ComboBox

    public ComboBox(ValueStack stack, jakarta.servlet.http.HttpServletRequest request, jakarta.servlet.http.HttpServletResponse response)

- ## Method Details

  - ### getDefaultTemplate

    protected String getDefaultTemplate()
    Description copied from class: `UIBean`
    A contract that requires each concrete UI Tag to specify which template should be used as a default. For example, the CheckboxTab might return "checkbox.vm" while the RadioTag might return "radio.vm". This value not begin with a '/' unless you intend to make the path absolute rather than relative to the current theme.
    Overrides:
      `getDefaultTemplate` in class `TextField`
    Returns:
      The name of the template to be used as the default.

  - ### evaluateExtraParams

    public void evaluateExtraParams()
    Overrides:
      `evaluateExtraParams` in class `TextField`

  - ### findListValue

    protected Object findListValue()

  - ### setList

    public void setList(String list)

  - ### setEmptyOption

    public void setEmptyOption(String emptyOption)

  - ### setHeaderKey

    public void setHeaderKey(String headerKey)

  - ### setHeaderValue

    public void setHeaderValue(String headerValue)

  - ### setListKey

    public void setListKey(String listKey)

  - ### setListValue

    public void setListValue(String listValue)